// startovn slo 05
unit main;
   
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ColorGrd, ComCtrls, ExtCtrls;

type TPole = record  // nadefinovn typu pro souadnice  x a y
      x: byte;
      y: byte;
   end;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    GroupBox1: TGroupBox;
    Button3: TButton;
    StringGrid1: TStringGrid;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button4: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    function HledaniDvojtecky(ActualPositionX,ActualPositionY: integer): TPole;
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;



var
  Form1: TForm1;
  mapa: array[1..255,1..255] of char;
  LastPositions:array[1..1000] of  TPole;
  pruchod: integer; 
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then Edit1.Text:=OpenDialog1.FileName; //naten hodnoty z dialogu otevt soubor do komponenty edit1
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if SaveDialog1.Execute then Edit2.Text:= SaveDialog1.FileName+'.txt'; //naten hodnoty z dialogu uloit soubor do komponenty edit2
 end;

procedure TForm1.Button3Click(Sender: TObject);
var maxX, maxY, i,k, radka, ActualX, ActualY : integer; 
    SouborMapy: TextFile;
    s: string;
    start, pomPole : TPole;
    Nalezeno : Boolean;

begin
 for i:= 1 to 1000 do begin
  LastPositions[i].x :=0;     // vyitn pole
  LastPositions[i].y :=0;
 end;
 if Edit1.Text = '' then begin     // oeten nezadn vstupnho souboru
  Application.MessageBox(PChar('Nen zadn vstupn soubor'),PChar('I/O error'),MB_ICONERROR);
  exit;
 end;
 if not FileExists(Edit1.Text) then begin // otestovn existence vstupnho souboru
  Application.MessageBox(PChar('Soubory mapy ( '+ edit1.text + ' ) neexistuje'),PChar('I/O error'), MB_ICONERROR);
  exit;
 end;

 if edit2.Text= '' then begin //oeten nezadn vstupnho souboru
  Application.MessageBox(PChar('Nebyl zadn vstupn soubor'),PChar('I/O error'),MB_ICONERROR);
  exit;
 end;


 AssignFile(SouborMapy,edit1.Text);  // naten vstupnho souboru
 Reset(SouborMapy);          // oteven souboru
 radka:= 0;                // inicializace promnn radka
 repeat
  radka := radka +1 ;        //ta
  Readln(SouborMapy,s);      //ten ze souboru
  maxY:=Length(s);       // zjitn ky mapy
  for i:= 1 to length(s) do begin         //uloen mapy do pole
   mapa[i,radka] := s[i];
   if (LowerCase(s[i]) = 's') then begin    // uloen souadnic startu
    start.x := i;
    start.y := radka;
   end;
  end;
 until Eof(SouborMapy);
 maxX:=radka;             // zjitn vky mapy
 CloseFile(SouborMapy);           //zaven souboru

 StringGrid1.ColCount:=maxY;   // nastaven komponenty StringGrig1
 StringGrid1.RowCount:=maxX;
 for i:= 1 to maxX do begin      //zobrazen mapy
  for k:= 1 to maxY do begin
   if mapa[i,k]= '.' then StringGrid1.Cells[i-1,k-1]:='*****';   // vpis silnice
   if mapa[i,k]=':' then StringGrid1.Cells[i-1,k-1]:='-----';    // vpis bezpen trasy na silnici
   if UpperCase(mapa[i,k])='X' then StringGrid1.Cells[i-1,k-1]:='X';  //vpis oblasti mimo silnici
   if UpperCase(mapa[i,k])='C' then StringGrid1.Cells[i-1,k-1]:='CL'; //cl
   if UpperCase(mapa[i,k])='S' then StringGrid1.Cells[i-1,k-1]:='STA';  //start
  end;
 end;

 // hledn bezpen trasy vyznaen znakem ":"
 nalezeno := false;   //inicializace promnnch
 ActualX:=start.x;
 ActualY:=start.y;
 repeat
   pomPole:= HledaniDvojtecky(ActualX,ActualY); // zavoln fce Hledani dvojtecky
   ActualX:=pomPole.x;               // peezen promnnch
   ActualY:=pomPole.y;
   if (Mapa[ActualX,ActualY] <> ':') then nalezeno := true;  //kontrola konce cesty
 until nalezeno;

 Memo1.Lines.Add('Tento soubor obasahuje pouze pozice, jak se automobil pohyboval'); // upozornn na nedokonalodt programu :-(
 for i:= 1 to pruchod do begin  //vpis pozic jak postupovala cesta
  memo1.Lines.Add(IntToStr(MaxX-LastPositions[i].x) + ','+ IntToStr(MaxY-LastPositions[i].y));
 end;
 Memo1.Lines.SaveToFile(Edit2.Text);  //uloen obasahu komponenty MEMO do souboru

 Application.MessageBox(PChar('Proces spn dokonen a vstupn soubor vytvoen !!'),PChar('Informace'),MB_ICONINFORMATION); // obdren zprvy o spnm konci
end;

function TForm1.HledaniDvojtecky(ActualPositionX,ActualPositionY: integer): TPole;
function control(x,y:integer): boolean; //fc kontrol kter kontroluje zda u bylo na pole vjeto
var i:integer;        //pokud na zadan pole nebylo vjeto
begin                 // fce vrac TRUE, pokud bylo vjeto fce vrac FALSE
 result:= true;
 for i:= 1 to pruchod do begin
  if (LastPositions[i].x = x) and (LastPositions[i].y = y) then result:=false;
 end;
end;

begin
  if (mapa[ActualPositionX -1,ActualPositionY] = ':') then // zjitn zda se na nsledujcch 8 vedlejch polokch nenachz :
  begin

  if control(ActualPositionX -1,ActualPositionY) then begin    //otestovan pole fc kontrol
   pruchod:=pruchod+1;
   LastPositions[pruchod].x:= ActualPositionX -1;  // uloen pozice X do do promnn
   LastPositions[pruchod].y :=ActualPositionY;     // uloen pozice Y do promnn
   result:=LastPositions[pruchod]; // vrcen hodnoty FCE
  end;
 end;
                                                          // pedchzejc postup se opakuje a do ukonen procedury
 if (mapa[ActualPositionX +1,ActualPositionY] = ':') then  begin
  if control(ActualPositionX +1,ActualPositionY) then begin
   pruchod:=pruchod+1;
   LastPositions[pruchod].x:= ActualPositionX +1;
   LastPositions[pruchod].y :=ActualPositionY;
   result:=LastPositions[pruchod];
  end;
 end;

 if (mapa[ActualPositionX +1,ActualPositionY+1] = ':') then
   begin
  if control(ActualPositionX +1,ActualPositionY+1) then begin
   pruchod:=pruchod+1;
   LastPositions[pruchod].x:= ActualPositionX +1;
   LastPositions[pruchod].y :=ActualPositionY+1;
   result:=LastPositions[pruchod];
  end;
 end;

 if (mapa[ActualPositionX +1,ActualPositionY-1] = ':') then begin
  if control(ActualPositionX +1,ActualPositionY-1) then begin
   pruchod:=pruchod+1;
   LastPositions[pruchod].x:= ActualPositionX +1;
   LastPositions[pruchod].y :=ActualPositionY-1;
   result:=LastPositions[pruchod];
  end;
 end;

 if (mapa[ActualPositionX -1,ActualPositionY+1] = ':') then begin
  if control(ActualPositionX -1,ActualPositionY+1) then begin
   pruchod:=pruchod+1;
   LastPositions[pruchod].x:= ActualPositionX -1;
   LastPositions[pruchod].y :=ActualPositionY+1;
   result:=LastPositions[pruchod];
  end;
 end;

 if (mapa[ActualPositionX -1,ActualPositionY-1] = ':') then begin
  if control(ActualPositionX -1,ActualPositionY-1) then begin
   pruchod:=pruchod+1;
   LastPositions[pruchod].x:= ActualPositionX -1;
   LastPositions[pruchod].y :=ActualPositionY-1;
   result:=LastPositions[pruchod];
  end;
 end;

 if (mapa[ActualPositionX,ActualPositionY +1] = ':') then begin
  if control(ActualPositionX,ActualPositionY+1) then begin
   pruchod:=pruchod+1;
   LastPositions[pruchod].x:= ActualPositionX;
   LastPositions[pruchod].y :=ActualPositionY+1;
   result:=LastPositions[pruchod];
  end;
 end;

 if (mapa[ActualPositionX,ActualPositionY-1] = ':') then begin
  if control(ActualPositionX,ActualPositionY-1) then begin
   pruchod:=pruchod+1;
   LastPositions[pruchod].x:= ActualPositionX;
   LastPositions[pruchod].y :=ActualPositionY-1;
   result:=LastPositions[pruchod];
  end;
 end;
 // KONEC PROCEDURY
end;
procedure TForm1.FormCreate(Sender: TObject);
begin
 pruchod:= 0;    //inicialiace prommn pruchod
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 Application.Terminate;   //ukonen aplikace
end;

end.
